package org.qtunes.auth.control;

import org.qtunes.core.Session;
import java.util.Map;
import java.util.List;

/**
 * A ParamParser converts from a String representation of a ControlMethod
 * into the actual objects required to invoke that method
 */
public interface ParamParser {

    public void parse(String in) throws Exception;

    /**
     * Get the name of the Object we want to invoke the method on
     */
    public String getObjectName();

    /**
     * Get the name of the ControlMethod we want to invoke
     */
    public List<Call> getMethodCalls();

    /**
     * Get the Session that was specified in the Parameters
     */
    public Session getSession();

    /**
     * Convert the specified Object to a String in a form that
     * would be usable by this ParamParser
     */
    public String toString(Object object);

}
