package org.qtunes.daap;

import org.qtunes.web.*;
import java.util.*;

class HandlerContentCodes extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) {
        ListBlock mccr = Blocks.create(Blocks.mccr);
        mccr.add(Blocks.create(Blocks.mstt, 200));
        List codes = Blocks.getContentCodes();
        for (int i=0;i<codes.size();i++) {
            Blocks.BlockDef def = (Blocks.BlockDef)codes.get(i);
            ListBlock mdcl = Blocks.create(Blocks.mdcl);
            mdcl.add(Blocks.create(Blocks.mcnm, def.getCode()));
            mdcl.add(Blocks.create(Blocks.mcna, def.getDescription()));
            mdcl.add(Blocks.create(Blocks.mcty, def.getType()));
            mccr.add(mdcl);
        }
        return mccr;
    }

    @Override boolean isSessionRequired() {
        return false;
    }

    @Override String getCacheKey(WebConnection con) {
        return "content-codes";
    }

}
