package org.qtunes.daap;

import org.qtunes.db.*;
import org.qtunes.web.*;
import java.io.*;
import java.util.*;

class HandlerEdit extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        final String action = con.getParameter("action");
        if (action.equals("add")) {
            String editparams = con.getParameter("edit-params");
            if (editparams.startsWith("'dmap.itemname:")) {
                String playlistname = editparams.substring(15, editparams.length() - 1);
                ManualPlaylist mpl = daap.getDatabase().createManualPlaylist();
                daap.getDatabase().putPlaylist(playlistname, mpl);

                DaapPlaylist playlist = DaapPlaylist.getInstance(daap, playlistname, mpl);
                ListBlock medc = Blocks.create(Blocks.medc);
                medc.add(Blocks.create(Blocks.mstt, 200));
                medc.add(Blocks.create(Blocks.miid, playlist.getIndex()));
                return medc;
            } else {
                throw new IllegalStateException("Unknown 'add' edit-params "+editparams);
            }
        } else {
            throw new IllegalStateException("Unknown edit action \""+action+"\"");
        }
    }

}
