package org.qtunes.daap;

import org.qtunes.web.*;
import org.qtunes.player.*;
import org.qtunes.speaker.*;
import java.io.*;
import java.util.*;

class HandlerGetSpeakers extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        ListBlock casp = Blocks.create(Blocks.casp);
        casp.add(Blocks.create(Blocks.mstt, 200));
//        casp.add(Blocks.create(Blocks.muty, 0));      // iTunes 91
        Player player = daap.getPlayer();
        Collection<Speaker> all = player.getAvailableSpeakers();
        Collection<Speaker> inuse = player.getSpeakers();
        for (Iterator<Speaker> i = all.iterator();i.hasNext();) {
            Speaker speaker = i.next();
            String name = speaker.getDisplayName();
            int id = speaker.getUniqueId();
            ListBlock mdcl = Blocks.create(Blocks.mdcl);
            mdcl.add(Blocks.create(Blocks.minm, name));
            mdcl.add(Blocks.create(Blocks.msma, id));
            if (inuse.contains(speaker)) {
                mdcl.add(Blocks.create(Blocks.caia, 1));
            }
            casp.add(mdcl);
        }

        return casp;
    }

}
