package org.qtunes.daap;

import org.qtunes.core.util.*;
import org.qtunes.db.*;
import org.qtunes.web.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;

class HandlerNowPlayingArtwork extends AbstractHandler {

    @Override
    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        Track track = daap.getPlayer().getCurrentTrack();
        int w = Integer.parseInt(con.getParameter("mw"));
        int h = Integer.parseInt(con.getParameter("mh"));
        handleArtwork(daap, con, track, w, h);
        return null;
    }

    @Override final boolean isStandardContentType() {
        return false;
    }

    protected void handleArtwork(DaapServer daap, WebConnection con, Track track, int w, int h) throws IOException {
        ByteBuffer buffer = null;
        String mimetype = null;
        if (track != null) {
            buffer = track.getImageBuffer();
            ByteBuffer newbuffer = ImageScaler.getInstance().getScaledImage(buffer, w, h, "JPG");
            if (newbuffer == buffer && buffer != null) {
                mimetype = (String)track.get(Field.ImageMIMEType);
            } else if (newbuffer != null) {
                mimetype = "image/jpeg";
            }
            buffer = newbuffer;
        }
        if (buffer != null) {
            con.addResponseHeader("Content-Type", mimetype);
            con.sendResponseHeaders(200, buffer.limit());
            WritableByteChannel channel = Channels.newChannel(con.getOutputStream());
            buffer.rewind();
            channel.write(buffer);
            buffer.rewind();
//            session.setTraffic(session.getTraffic() + n);
            channel.close();
        } else {
            con.sendResponseHeaders(404, -1);
        }
    }

}
