package org.qtunes.daap;

import org.qtunes.player.*;
import org.qtunes.speaker.*;
import org.qtunes.web.*;
import java.io.*;
import java.util.*;

class HandlerSetProperty extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        String val;
        Player player = daap.getPlayer();
        if ((val=con.getParameter("dmcp.volume"))!=null) {
            player.setVolume(Integer.parseInt(val));
        }
        if ((val=con.getParameter("dacp.repeatstate"))!=null) {
            player.setRepeat(Integer.parseInt(val));
        }
        if ((val=con.getParameter("dacp.shufflestate"))!=null) {
            player.setShuffle("1".equals(val));
        }
        if ((val=con.getParameter("dacp.playingtime"))!=null) {
            player.seek(Integer.parseInt(val));
        }
        if ((val=con.getParameter("speaker-id"))!=null) {
            String[] z = val.split(",");
            Collection<Speaker> speakers = player.getAvailableSpeakers();
            List<Speaker> newspeakers = new ArrayList<Speaker>();
            for (int i=0;i<z.length;i++) {
                try {
                    // Long.decode requires +ve values
                    if (z[i].startsWith("0xffffffff") && z[i].length()==18) {
                        z[i] = "0x"+z[i].substring(10);
                    }
                    int id = Long.decode(z[i]).intValue();
                    for (Iterator<Speaker> j = speakers.iterator();j.hasNext();) {
                        Speaker speaker = j.next();
                        if (speaker.getUniqueId() == id) {
                            newspeakers.add(speaker);
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            Collection<Speaker> oldspeakers = player.getSpeakers();
            oldspeakers.removeAll(newspeakers);
            try {
                for (Iterator<Speaker> i = oldspeakers.iterator();i.hasNext();) {
                    Speaker speaker = i.next();
                    speaker.setPlayer(null);
                }
                for (Iterator<Speaker> i = newspeakers.iterator();i.hasNext();) {
                    Speaker speaker = i.next();
                    speaker.setPlayer(player);
                }
            } catch (Exception e) {
                daap.getServiceContext().warn("Set Speakers", e);
            }
        }
        con.setResponseHeader("Content-encoding", (String)null);
        con.sendResponseHeaders(204, -1);
        return null;
    }

}
