package org.qtunes.ff.spi.mp3;

import java.io.*;
import java.nio.*;

/**
 * Type of Tag that stores its value as a 4-byte big-endian integer. Not currently used
 */
class TagInteger extends Tag {

    private boolean read;
    private int value;

    TagInteger() {
    }

    private synchronized void parse() throws IOException {
        if (!read) {
            try {
                ByteBuffer data = getContent();
                data.rewind();
                value = data.getInt();
                read = true;
            } catch (BufferUnderflowException e) {
                throw new IOException(e);
            }
        }
    }

    int getValue() throws IOException {
        parse();
        return value;
    }

    public String toString() {
        try {
            return "["+getName()+" value="+getValue()+"]";
        } catch (IOException e) {
            return super.toString();
        }
    }

}
