Ext.ns("QTunes");
QTunes.Playlist = Ext.extend(Ext.util.Observable, (function() {

var qtunes;

return {

    properties: false,

    constructor: function(config) {
        qtunes = config.qtunes;
        this.addEvents({"update": true});
        this.listeners = config.listeners;

        this.getId = function() {
            return config.id;
        };

        this.getName = function() {
            return config.name;
        };

        this.getDisplay = function() {
            return config.display;
        };

        this.isSmart = function() {
            return config.smart || config.root || config.nowplaying;
        };

        this.isRoot = function() {
            return config.root;
        };

        this.isNowPlaying = function() {
            return config.nowplaying;
        };

        this.toString = function() {
            if (this.isRoot()) {
                return "[Root Playlist]";
            } else if (this.isNowPlaying()) {
                return "[Current Playlist]";
            } else {
                return "[Playlist "+this.getName()+"]";
            }
        };

        QTunes.Playlist.superclass.constructor.call(this, config);
        this.update(config);

    },
    
    update: function(properties) {
        var oldrevision = this.getRevision();
        this.properties = properties;
        if (oldrevision != this.getRevision()) {
            this.fireEvent("update");
        }
    },

    getRevision: function() {
        if (this.isNowPlaying()) {
            return qtunes.getPlayer() ? qtunes.getPlayer().getRevision() : -1;
        } else {
            return this.properties ? this.properties.revision : -1;
        }
    },

    getSize: function() {
        return this.properties.size;
    },

    getQuery: function() {
        return this.properties.query;
    },

};

}()));
